library KTKbdHk3;
{//This library contains functions to help implement
 system keyboard hook.
//}
uses
Windows;
{$R *.RES}
//-----------Data Structure to be shared------------//
const MAX_HOOKS=300;
type TKeyHook=record
       Handle,Msg:Cardinal;
       Active,           //Indicates, whether this entry is active
       PassThru:Boolean; //Indicates, whether the hook is "Transparent"
     end;
     TKeyHooks=record
       hHook:Cardinal;   //Actually, we make just 1 hook
       Count:Cardinal;   //For convenience - we'll thus track the number of active hooks
       Passthru:Boolean; //For convenience - a variable, that tells whether we need to pass the msg. Must be reset every time a Passthru of some hook changes.
       Hook:array[1..MAX_HOOKS] of TKeyHook;       //Cannot have more than 300 hooks
     end;
     TMyData=record
       Instances:Cardinal;  //Number of processes, that use the DLL
       KeyHooks:TKeyHooks;
     end;
     PMyData=^TMyData;

const
//--------Constants (2 stupid strings)---------------------//
   MutexName='KTKeyboardHookLibraryVersion3.00SpecialEditionUniqueMutexName';
   MemShareName='KTKHLV300SEMEMFILE';

//------------------Variables-------------------------//
var
   MyMutex, //Synchronization Mutex Handle
   MemShare:Cardinal;  //Memory-Mapped File handle
   MyData:PMyData;   //Library-Shared Data


//-----------------Keyboard Hook Callback---------------//
function KbdHook(hCode,wParam:LongInt;lParam:LongInt):Longint;stdcall;
var i:Integer; CountDown:Cardinal;
begin
     try
       WaitForSingleObject(MyMutex,INFINITE); //Synchronize
       with MyData^.KeyHooks do begin
            if hCode=HC_ACTION then begin
       //Notify all applications, using the DLL
               CountDown:=Count;
               for i:=1 to MAX_HOOKS do
                   if Hook[i].Active then begin
                      PostMessage(Hook[i].Handle,Hook[i].Msg,wParam,lParam);
                      Dec(CountDown);
                      if CountDown=0 then Break;
               end;
            end;
       //Pass on (or not)
            if (hHook <> 0) then begin
               if (PassThru=False) then Result:=-1
               else Result:=CallNextHookEx(hHook,hCode,wParam,lParam)
            end else Result:=0
       end; //with
     finally ReleaseMutex(MyMutex);
     end;
end;

//-------------Function to set hook----------------//
function HookKeyboard(Hwnd,MsgID:Cardinal):Cardinal;stdcall;
var i:Integer;
begin
     try
     WaitForSingleObject(MyMutex,INFINITE); //Synchronize
     with MyData^.KeyHooks do begin
//Find a free entry
          Result:=0;
          for i:=1 to MAX_HOOKS do
              if Hook[i].Active=False then begin
                 Result:=i;
                 Break;
          end;
//set the hook, if we need to
          if hHook=0 then hHook:=SetWindowsHookEx(WH_KEYBOARD,@KbdHook,HInstance,0);
          if hHook=0 then Result:=0
           else begin
//add an entry
             Inc(Count);
             Hook[Result].Msg:=MsgID;
             Hook[Result].Handle:=Hwnd;
             Hook[Result].PassThru:=True;
             Hook[Result].Active:=True;
          end;
     end; //with
     finally ReleaseMutex(MyMutex);
     end;
end;
//------------------Function to remove Hook----------------//
function UnhookKeyboard(Index:Cardinal):Boolean;stdcall;
var i:Integer; CountDown:Cardinal;
begin
     try
      WaitForSingleObject(MyMutex,INFINITE);
      Result:=True;
      with MyData^.KeyHooks do begin
//Check if the index is specified correctly (as it is done in every function)
       if (Index<1) or (Index>MAX_HOOKS) then begin
          Result:=False; ReleaseMutex(MyMutex); Exit;
       end;

       if Hook[Index].Active then begin
          Hook[Index].Active:=False;
          Dec (Count);
//if there are no more hook entries, then unhook keyboard
          if Count=0 then begin
             if hHook=0 then begin
                ReleaseMutex(MyMutex);Exit;
             end;
             Result:=UnhookWindowsHookEx(hHook);
             hHook:=0;
             Passthru:=True;
          end else begin
//Reconsider the Passthru value
             Passthru:=True;
             CountDown:=Count;
             for i:=1 to MAX_HOOKS do
                 if Hook[i].Active then begin
                    Passthru:=(Passthru and Hook[i].PassThru);
                    Dec(CountDown);
                    if CountDown=0 then Break;
             end;  //for
           end;//if Count=0...
         end; //if hook.active...
      end; // with
     finally ReleaseMutex(MyMutex);
     end;
end;

//-----------Function to determine, whether we are already hooked-----------//
//---returns the handle of the hook---//
function Hooked(Index:Cardinal):Boolean;stdcall;
begin
     WaitForSingleObject(MyMutex,INFINITE);
     if (Index<1) or (Index>MAX_HOOKS) then Result:=False
        else Result:=((MyData^.KeyHooks.hHook<>0) and MyData^.KeyHooks.Hook[Index].Active);
     ReleaseMutex(MyMutex);
end;
//-----------Set the "PassThru" variable. If it is "True",-------------------//
//--then Keyboard messages are passed thru to other hooks and target window--//
//--Returns the old Passthru value--//
function SetPassthru(Index:Cardinal; NewPassthru:Boolean):Boolean;stdcall;
var i:Integer; CountDown:Cardinal;
begin
     WaitForSingleObject(MyMutex,INFINITE);
     if (Index<1) or (Index>MAX_HOOKS) then Result:=False
        else with MyData^.KeyHooks do begin
         Result:=Hook[Index].Passthru;
         Hook[Index].Passthru:=NewPassthru;
//if there are several entries, then we won't passthru in case any of them doesn't want us
         if NewPassthru=False then Passthru:=False else begin
//search for negative passthrus
             Passthru:=True;
             CountDown:=Count;
             for i:=1 to MAX_HOOKS do
                 if Hook[i].Active then begin
                    Passthru:=(Passthru and Hook[i].Passthru);
                    Dec(CountDown);
                    if CountDown=0 then Break;
             end;
         end;
     end;
     ReleaseMutex(MyMutex);
end;
//-----------This one just gets the value of the Passthru var-------------//
function GetPassthru(Index:Cardinal):Boolean;stdcall;
begin
     WaitForSingleObject(MyMutex,INFINITE);
     if (Index<1) or (Index>MAX_HOOKS) then Result:=False
        else Result:=MyData^.KeyHooks.Hook[Index].Passthru;
     ReleaseMutex(MyMutex);
end;

//=========================DLL Mechanics======================//
//--------------Initialization Code--------------//
procedure EnterDLL;stdcall;
var FirstInstance:Boolean;
begin
//Get a Mutex for synchronization
     MyMutex:=CreateMutex(nil,True,MutexName);
//Open Memory Share
     MemShare:=OpenFileMapping(FILE_MAP_ALL_ACCESS,False,PChar(MemShareName));
     FirstInstance:=(MemShare=0);
//If cannot open, then create
     if MemShare=0 then MemShare:=CreateFileMapping($FFFFFFFF,nil,PAGE_READWRITE,0,SizeOf(TMyData),MemShareName);
     if MemShare<>0 then begin
        //we are opened for the first time...
        MyData:=MapViewOfFile(MemShare,FILE_MAP_ALL_ACCESS,0,0,0);
        if FirstInstance=False then FirstInstance:=(MyData^.Instances=0);  //this IS needed
        if Firstinstance then begin
           FillChar(MyData^,SizeOf(TMyData),0);
           MyData^.KeyHooks.Passthru:=True;
        end;
        Inc(MyData^.Instances);
     end;
     ReleaseMutex(MyMutex);
end;
//--------------DeInitialization Code---------------//
procedure ExitDLL;stdcall;
begin
    try
//Synchronize
      WaitForSingleObject(MyMutex,INFINITE);
      Dec(MyData^.Instances);
      if (MyData^.Instances=0) then begin
//Close shared memory file and synchronization mutex
         UnmapViewOfFile(MyData);
         CloseHandle(MemShare);
         CloseHandle(MyMutex);
       end;
     finally ReleaseMutex(MyMutex);
     end;
end;
//-----------------DllEntryPoint----------//
procedure LibraryProc(Reason: Integer);
begin
 case Reason of
   DLL_PROCESS_DETACH:ExitDll;
   DLL_PROCESS_ATTACH:EnterDll;
 end;
end;
//-----------------Exports...-----------------//
exports HookKeyboard,UnhookKeyboard,Hooked,GetPassthru,SetPassthru;
//--------------------------------------------------------//
begin
EnterDLL;
DllProc:=@LibraryProc;
end.
//Copyright2000, Konstantin Tretyakov