VERSION 5.00
Begin VB.UserControl KeyMon 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   CanGetFocus     =   0   'False
   ClientHeight    =   555
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   555
   ClipBehavior    =   0  'None
   Enabled         =   0   'False
   FontTransparent =   0   'False
   HasDC           =   0   'False
   HitBehavior     =   0  'None
   InvisibleAtRuntime=   -1  'True
   Picture         =   "KeyMon.ctx":0000
   ScaleHeight     =   37
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   37
   ToolboxBitmap   =   "KeyMon.ctx":0366
End
Attribute VB_Name = "KeyMon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Keyboard monitor ActiveX
'Copyright 2000, Konstantin Tretyakov (kt_ee@hotmail.com)
'Visit:     http://smartsite.cjb.net

'If you somehow manage to improve this code or just find bugs in it,
'please tell me. Also, if you make some interesting program with it,
'I'd be glad if you showed it to me

Option Explicit
Private phHook As Long
Private pbPassthru As Long
Private puMacroLogType As KTMacroLogType
Private pcMacros As New Collection
Private pcMacroKeys As New Collection 'Here we'll store macro keys. We could omit it if there was a possibility
                                        'to get a collection's item's Key from its index
Private KbdBuffer As String 'Here we'll store info on pressed keys, so that we can then find macro combinations

Const MAX_MACRO_LEN = 500   'I think that'll be enough
                            'In fact it is better to reduce the nuber for speed

Const KMID = "Keyboard Monitor ActiveX"
Const ERR500 = "Critical Error: Unable to subclass control's window, cannot proceed normally."
Const ERR501 = "System error: Unable to remove hook."
Const ERR502 = "Unable to set hook. Either the DLL is being used by another application or system error. Cannot proceed normally"
Const ERR503 = "Keylogger ActiveX was not designed to work with macros longer than " & MAX_MACRO_LEN & " symbols"

Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_Description = "Happens, when a key is being pushed."
Public Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "Happens, when a key is pressed."
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_Description = "Happens when a key is released."
Public Event KeyUpEx(KeyText As String)
Attribute KeyUpEx.VB_Description = "Same as KeyUp, only the passed parameter is a string, identifyinfg the key."
Public Event KeyDownEx(KeyText As String)
Attribute KeyDownEx.VB_Description = "Same as Keydown, but passes only 1 string parameter, describing the key pressed."
Public Event Macro(MacroKey As String)

Public Enum KTLogType   'We can log chars or keys
    kmLogKeys = 0       'If we log chars, then the control reports us, the character, being transferred
    kmLogChars = 1      'Logging Keys returns the key pressed. The difference with logging
                        'Chars involves only alpha-numeric keys.
                        'That is, when you hold shift and press 1, then the Key pressed is "1", but the character transferred is "!"
                        'And with alpha-keys its like that: if you log Keys, then you will always be reported an uppercase letter
                        'Whether you hold shift or not. Logging chars allows you to see, what letter was really meant, that is
                        'If I press "A", then the key pressed is "A", and the character is "a" (if we don't hold shift)
End Enum

Public Enum KTMacroLogType
    kmConsiderKeyDowns = 0  'When a key should be considered as "pressed" - when it's down, or when it's up
    kmConsiderKeyUps = 1    'Warning - if you enable the AcceptRepeats property, then a key, that is held down will be considered as a
                            'series of keydowns, and that won't suit for kmConsiderKeyDowns then
                            'However, you may make a macro, that is executed after
                            'Shift is KeyDown-ed 50 times, enable AcceptRepeats, and then
                            'Your macro will be executed after holding down Shift for a while
End Enum

Private Sub UserControl_Initialize()
'Set the control's windowproc
    PrevFuncPointer = SetWindowLong(UserControl.hwnd, GWL_WNDPROC, AddressOf Window_OnMessage)
    If (PrevFuncPointer = 0) Then
        'Cry out loud
        Err.Raise vbObjectError + 500, KMID, ERR500
        Unload Me
    End If
    SetProp UserControl.hwnd, "PrevFuncPointer", PrevFuncPointer
'Because of the fact, that VB is stupid enough not to allow me access
'My control's variables, properties & events from within my control's
'Windowproc, I have to make everything here the rough way, including the
'handling of some properties
    SetProp UserControl.hwnd, "AcceptRepeats", 0
    SetProp UserControl.hwnd, "LogType", kmLogKeys
    SetProp UserControl.hwnd, "DifferNumpad", 0
End Sub

Private Sub UserControl_InitProperties()
    Dim I As Integer
    phHook = 0
    pbPassthru = True
    puMacroLogType = kmConsiderKeyDowns
    For I = 1 To pcMacroKeys.Count
        pcMacros.Remove I
        pcMacroKeys.Remove I
    Next
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim I As Integer, sK As String
    If HadEvent Then
        If EventKeyDown Then
            RaiseEvent KeyDownEx(EventKeyText)
        Else
            RaiseEvent KeyUpEx(EventKeyText)
        End If
        'Now check for macros
        If ((puMacroLogType = kmConsiderKeyDowns) And EventKeyDown) Or ((puMacroLogType = kmConsiderKeyUps) And Not EventKeyDown) Then
            KbdBuffer = KbdBuffer + EventKeyText
            If Len(KbdBuffer) > MAX_MACRO_LEN Then KbdBuffer = Right(KbdBuffer, MAX_MACRO_LEN)
            For I = 1 To pcMacroKeys.Count
                sK = pcMacroKeys(I)
                If Right(KbdBuffer, Len(pcMacros(sK))) = pcMacros(sK) Then RaiseEvent Macro(sK)
            Next
        End If
    End If
End Sub

Private Sub UserControl_Resize()
    Width = Screen.TwipsPerPixelX * 37
    Height = Screen.TwipsPerPixelY * 37
End Sub

Public Property Get Passthru() As Boolean
Attribute Passthru.VB_Description = "Set this property to False to prevent the keyboard messages from reaching their target. Works in design time also :)"
    Passthru = pbPassthru
End Property

Public Property Let Passthru(ByVal NewValue As Boolean)
    pbPassthru = NewValue
    If Hooked(phHook) Then SetPassthru phHook, NewValue
End Property

Public Property Get Active() As Boolean
Attribute Active.VB_Description = "Enables/Disables the hook.\r\nRaises an error if failed."
    Active = Hooked(phHook)
End Property

Public Property Let Active(ByVal NewValue As Boolean)
    If NewValue = False Then
        If Deactivate = False Then Err.Raise vbObjectError + 501, KMID, ERR501
    Else
        If Activate = False Then Err.Raise vbObjectError + 502, KMID, ERR502
    End If
    PropertyChanged "Passthru"
End Property

Public Property Let AcceptRepeats(ByVal NewValue As Boolean)
Attribute AcceptRepeats.VB_Description = "Specifies, if the control should report the repeated keystrokes."
    If NewValue Then SetProp UserControl.hwnd, "AcceptRepeats", -1 _
      Else SetProp UserControl.hwnd, "AcceptRepeats", 0
End Property

Public Property Get AcceptRepeats() As Boolean
    AcceptRepeats = GetProp(UserControl.hwnd, "AcceptRepeats")
End Property

Public Property Let DifferNumpad(ByVal NewValue As Boolean)
Attribute DifferNumpad.VB_Description = "Set it to True if you wish to differ the numbers on the keypad. E.G. if it is true, and a 9 on the Numpad is pressed, the control will report a {Numpad9} keypress."
    If NewValue Then SetProp UserControl.hwnd, "DifferNumpad", -1 _
      Else SetProp UserControl.hwnd, "DifferNumpad", 0
End Property

Public Property Get DifferNumpad() As Boolean
    DifferNumpad = GetProp(UserControl.hwnd, "DifferNumpad")
End Property

Public Property Let LogType(ByVal NewValue As KTLogType)
Attribute LogType.VB_Description = "Specifies, what should be reported in KeyUpEx or KeyDownEx events, when a shift and a Alpha-Numeric key is pressed. If you log keys, then there is no difference, whether shift is held or not."
    SetProp UserControl.hwnd, "LogType", NewValue
End Property

Public Property Get LogType() As KTLogType
    LogType = GetProp(UserControl.hwnd, "LogType")
End Property

Public Property Let MacroLogType(ByVal NewValue As KTMacroLogType)
Attribute MacroLogType.VB_Description = "Specified, when should a key be considered as ""pressed"" - either when it is pushed, or when it is released."
    puMacroLogType = NewValue
End Property

Public Property Get MacroLogType() As KTMacroLogType
    MacroLogType = puMacroLogType
End Property

Public Property Get Macro(ByVal Key As String) As String
Attribute Macro.VB_Description = "An event, that is fired, when one of the defined macros has been typed by a user."
    Dim MacroText As String
    On Error Resume Next
    MacroText = pcMacros(Key)
    If Err <> 0 Then
        Err.Clear
        Macro = ""
    Else
        Macro = MacroText
    End If
End Property

Public Property Let Macro(ByVal Key As String, ByVal NewMacro As String)
    Dim MacroText As String
    Dim I As Integer
    If Len(NewMacro) > MAX_MACRO_LEN Then  'We can't have too long macros
        Err.Raise vbObjectError + 503, KMID, ERR503
        Exit Property
    End If
    
    On Error Resume Next
    MacroText = pcMacros(Key)
    If Err <> 0 Then 'We have no such entry
        Err.Clear
        If NewMacro <> "" Then
            pcMacros.Add NewMacro, Key
            pcMacroKeys.Add Key
        End If
    Else
        If NewMacro = "" Then
            pcMacros.Remove Key
            For I = 1 To pcMacroKeys.Count
                If pcMacroKeys(I) = Key Then
                    pcMacroKeys.Remove I
                    Exit For
                End If
            Next
        Else
            pcMacros(Key) = NewMacro
        End If
    End If
End Property
Public Function Activate() As Boolean
Attribute Activate.VB_Description = "Activate the Keyboard hook.\r\nEqual to setting the Active property to True. Returns False if Failed."
    If Hooked(phHook) Then
        Activate = True
        Exit Function
    End If
    phHook = HookKeyboard(UserControl.hwnd, MyOwnMessage)
    Activate = Hooked(phHook)
    If Activate Then pbPassthru = True
End Function

Public Function Deactivate() As Boolean
Attribute Deactivate.VB_Description = "Deactivates the hook.\r\nEqual to setting the Active property to False. Returns False if failed."
    If Hooked(phHook) Then
       Deactivate = UnhookKeyboard(phHook)
    Else
        Deactivate = True
    End If
    phHook = 0
End Function

Private Sub UserControl_Terminate()
    Deactivate
    SetWindowLong UserControl.hwnd, GWL_WNDPROC, GetProp(UserControl.hwnd, "PrevFuncPointer")
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    pbPassthru = PropBag.ReadProperty("Passthru", True)
    If Hooked(phHook) Then SetPassthru phHook, pbPassthru
    If PropBag.ReadProperty("Active", False) <> (Hooked(phHook) <> 0) Then _
        Active = PropBag.ReadProperty("Active", False)
    SetProp UserControl.hwnd, "AcceptRepeats", IIf(PropBag.ReadProperty("AcceptRepeats", False), -1, 0)
    SetProp UserControl.hwnd, "DifferNumpad", IIf(PropBag.ReadProperty("DifferNumpad", False), -1, 0)
    SetProp UserControl.hwnd, "LogType", PropBag.ReadProperty("LogType", kmLogKeys)
    puMacroLogType = PropBag.ReadProperty("MacroLogType", kmConsiderKeyDowns)
End Sub


Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Active", Hooked(phHook)
    PropBag.WriteProperty "Passthru", pbPassthru
    PropBag.WriteProperty "AcceptRepeats", IIf(GetProp(UserControl.hwnd, "AcceptRepeats") = 0, False, True)
    PropBag.WriteProperty "DifferNumpad", IIf(GetProp(UserControl.hwnd, "DifferNumpad") = 0, False, True)
    PropBag.WriteProperty "LogType", GetProp(UserControl.hwnd, "LogType")
    PropBag.WriteProperty "MacroLogType", puMacroLogType
End Sub
